local addonName, AL = ...
local tinsert, tremove, GetAddOnMetadata, RequestTimePlayed = tinsert, tremove, GetAddOnMetadata, RequestTimePlayed
local requesting
local o = ChatFrame_DisplayTimePlayed

function AL:sendLeaderboardMessage(msg)
    DEFAULT_CHAT_FRAME:AddMessage("|c006969FF[AL] Achievement Leaderboard: |r" .. tostring(msg))
end

function AL:getVersion()
    return GetAddOnMetadata(addonName, "Version") or 9999;
end

function AL:RequestTimePlayed()
	requesting = true
	RequestTimePlayed()
end

ChatFrame_DisplayTimePlayed = function(...)
	if requesting then
		requesting = false
		return
	end
	return o(...)
end

function AL:TIME_PLAYED_MSG(timePlayed, ...)
	-- do nothing, dont show time message! only when /played
end

function AL:cleanOldCharacters()
    local characters = {}
    local removeTotal = 0
    for guidId, data in pairs(ALBDCharactersData) do
        if data.characterInfo == nil or data.characterInfo.battleTag == nil then
            ALBDCharactersData[guidId] = nil
            removeTotal = removeTotal+1
        end
    end
end

function AL:getMyCharacters()
    local myCharacters = {}
    for guidId, data in pairs(ALBDCharactersData) do
        if data["characterInfo"] ~= nil and data["characterInfo"]["battleTag"] ~= nil then
            local character = data["characterInfo"]
            local actualPoints = AL:getActualPoints(character.guid)
            local isMain = (character.guid == AL.settings.mainCharacter)

            tinsert(myCharacters, {
                name = character["name"],
                realm = character["realm"],
                guid = guidId,
                points = character["points"],
                ap = actualPoints,
                updated = character["updated"],
                class = character["class"],
                main = isMain
            })
        end
    end
    AL.tempStore.myCharacters = myCharacters
end

function AL:removeCharacter(guid)
    ALBDCharactersData[guid] = nil;
    AL:getMyCharacters()
end

function AL:getMainCharacter()
    local characterData = AL.settings.myCharacters
    if characterData ~= nil and #characterData > 0 then
        for _, data in ipairs(characterData) do
            if data.main == true then
                return data
            end
        end
    end
    return ""
end

function AL:sendAchievementAnnouncement(msg)
	if AL.settings.guildChat == true then
		SendChatMessage("[Leaderboard] "..msg, "GUILD", nil, nil)
	end
	if AL.settings.partyChat == true then
		SendChatMessage("[Leaderboard] "..msg, "PARTY", nil, nil)
	end
	if AL.settings.raidChat == true then
		SendChatMessage("[Leaderboard] "..msg, "RAID", nil, nil)
	end
end