local addonName, AL = ...
local version = GetAddOnMetadata(addonName, "Version") or 9999;
local E
AL.tempStore = AL.tempStore or {}
AL.ElvUI = false

local leaderboardFrameOne = CreateFrame("Frame", "ALDBLeaderboardFrame", UIParent, "BackdropTemplate")
leaderboardFrameOne:SetPoint("CENTER", 0, 0)
leaderboardFrameOne:Show()
local backdrop = {
    bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
    edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
    tile = true, tileSize = 16, edgeSize = 16,
    insets = { left = 4, right = 4, top = 4, bottom = 4 }
}
if IsAddOnLoaded("ElvUI") then
    E = unpack(ElvUI)
    AL.ElvUI = true
    leaderboardFrameOne:SetTemplate("Transparent")
    local r, g, b = unpack(E.media.backdropcolor)
    leaderboardFrameOne:SetBackdropColor(r, g, b, 0.7)
    leaderboardFrameOne:SetBackdropBorderColor(unpack(E.media.bordercolor))
else 
    leaderboardFrameOne:SetBackdrop(backdrop)
    leaderboardFrameOne:SetBackdropColor(0, 0, 0, 0.95)
end
leaderboardFrameOne:SetSize(750, 550)
leaderboardFrameOne:SetMovable(true)
leaderboardFrameOne:EnableMouse(true)
leaderboardFrameOne:RegisterForDrag("LeftButton")
leaderboardFrameOne:SetFrameStrata('DIALOG')
leaderboardFrameOne:SetScript("OnDragStart", function(self, button)
	self:StartMoving()
end)
leaderboardFrameOne:SetScript("OnDragStop", function(self)
	self:StopMovingOrSizing()
end)
leaderboardFrameOne:Hide()
local isUpdatingRealmData = false
local isUpdatingGuildData = false
local isUpdatingLeaderboardData = false
local firstLoad = true

leaderboardFrameOne:SetScript("OnShow", function (leaderboardFrameOne)
    if not leaderboardFrameOne.btnClose  then
        leaderboardFrameOne.btnClose = CreateFrame("Button", nil, leaderboardFrameOne, "UIPanelCloseButton")
        leaderboardFrameOne.btnClose:SetPoint("TOPRIGHT", 0, 0)
        leaderboardFrameOne.btnClose:SetSize(30, 30)
        leaderboardFrameOne.btnClose:SetScript("OnClick", function(self)
            AL:hideLeaderboard()
        end)
    end
    if not leaderboardFrameOne.versionText then
        leaderboardFrameOne.versionText = leaderboardFrameOne:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
        leaderboardFrameOne.versionText:SetPoint("TOPRIGHT", -40, -10)
        leaderboardFrameOne.versionText:SetText("Achievement Leaderboard Exporter "..version)  
    end
    
    if not leaderboardFrameOne.btnStatus  then
        leaderboardFrameOne.btnStatus = CreateFrame("Button", nil, leaderboardFrameOne, "UIPanelButtonTemplate")
        leaderboardFrameOne.btnStatus:SetPoint("TOPLEFT", 10, -10)
        leaderboardFrameOne.btnStatus:SetSize(100, 30)
        leaderboardFrameOne.btnStatus:SetText("Status")
        leaderboardFrameOne.btnStatus:SetScript("OnClick", function(self)
            showCharacterStatus()
        end)
    end
    
    if  not leaderboardFrameOne.btnRealm  then
        leaderboardFrameOne.btnRealm = CreateFrame("Button", nil, leaderboardFrameOne, "UIPanelButtonTemplate")
    end
    leaderboardFrameOne.btnRealm:SetPoint("TOPLEFT", 110, -10)
    leaderboardFrameOne.btnRealm:SetSize(150, 30)
    leaderboardFrameOne.btnRealm:SetText("Select Main Characters")
    leaderboardFrameOne.btnRealm:SetScript("OnClick", function(self)
        createMycharacterFrame()
    end)

    if not leaderboardFrameOne.btnGuild  then
        leaderboardFrameOne.btnGuild = CreateFrame("Button", nil, leaderboardFrameOne, "UIPanelButtonTemplate")
    end
    leaderboardFrameOne.btnGuild:SetPoint("TOPLEFT", 260, -10)
    leaderboardFrameOne.btnGuild:SetSize(100, 30)
    leaderboardFrameOne.btnGuild:SetText("Guild")
    leaderboardFrameOne.btnGuild:SetScript("OnClick", function(self)
        createGuildInfoScreen()
    end)

    if not leaderboardFrameOne.btnSettings  then
        leaderboardFrameOne.btnSettings = CreateFrame("Button", nil, leaderboardFrameOne, "UIPanelButtonTemplate")
        leaderboardFrameOne.btnSettings:SetPoint("BOTTOMRIGHT", -210, 10)
        leaderboardFrameOne.btnSettings:SetSize(100, 30)
        leaderboardFrameOne.btnSettings:SetText("Settings")
        leaderboardFrameOne.btnSettings:SetScript("OnClick", function(self)
            if Settings and Settings.OpenToCategory then
                Settings.OpenToCategory("AlbdAddonSettings")
            end
            AL:hideLeaderboard()
        end)
    end    
    if not leaderboardFrameOne.btnExport  then
        leaderboardFrameOne.btnExport = CreateFrame("Button", nil, leaderboardFrameOne, "UIPanelButtonTemplate")
        leaderboardFrameOne.btnExport:SetPoint("BOTTOMRIGHT", -110, 10)
        leaderboardFrameOne.btnExport:SetSize(100, 30)
        leaderboardFrameOne.btnExport:SetText("Export")
        leaderboardFrameOne.btnExport:SetScript("OnClick", function(self)
            AL:showExport()
        end)
    end  
    if not leaderboardFrameOne.btnExit  then
        leaderboardFrameOne.btnExit = CreateFrame("Button", nil, leaderboardFrameOne, "UIPanelButtonTemplate")
        leaderboardFrameOne.btnExit:SetPoint("BOTTOMRIGHT", -10, 10)
        leaderboardFrameOne.btnExit:SetSize(100, 30)
        leaderboardFrameOne.btnExit:SetText("Close")
        leaderboardFrameOne.btnExit:SetScript("OnClick", function(self)
            AL:hideLeaderboard()
        end)
    end
    if not leaderboardFrameOne.ColumnHeaderFrame then
        leaderboardFrameOne.ColumnHeaderFrame = CreateFrame("Frame", "LeaderboardColumnHeaderFrame", leaderboardFrameOne)
        leaderboardFrameOne.ColumnHeaderFrame:SetPoint("TOPLEFT", leaderboardFrameOne, "TOPLEFT", 10, -75)
        leaderboardFrameOne.ColumnHeaderFrame:SetSize(650, 10)
        
        leaderboardFrameOne.ColumnHeaderFrame.column1Label = leaderboardFrameOne.ColumnHeaderFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        leaderboardFrameOne.ColumnHeaderFrame.column1Label:SetPoint("LEFT", 10, 0)
        leaderboardFrameOne.ColumnHeaderFrame.column1Label:SetText("Points")
        
        leaderboardFrameOne.ColumnHeaderFrame.column2Label = leaderboardFrameOne.ColumnHeaderFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        leaderboardFrameOne.ColumnHeaderFrame.column2Label:SetPoint("LEFT", 160, 0)
        leaderboardFrameOne.ColumnHeaderFrame.column2Label:SetText("Name")

        leaderboardFrameOne.ColumnHeaderFrame.column3Label = leaderboardFrameOne.ColumnHeaderFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        leaderboardFrameOne.ColumnHeaderFrame.column3Label:SetPoint("LEFT", 410, 0)
        leaderboardFrameOne.ColumnHeaderFrame.column3Label:SetText("Last Seen")

        leaderboardFrameOne.ColumnHeaderFrame.column4Label = leaderboardFrameOne.ColumnHeaderFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        leaderboardFrameOne.ColumnHeaderFrame.column4Label:SetPoint("LEFT", 520, 0)
        leaderboardFrameOne.ColumnHeaderFrame.column4Label:SetText("")

        leaderboardFrameOne.ColumnHeaderFrame:Hide()
    end
    if firstLoad then
        showCharacterStatus()
        firstLoad = false
    end

    if AL.ElvUI == true then
        leaderboardFrameOne.btnStatus:SetTemplate("Transparent")
        leaderboardFrameOne.btnStatus:SetBackdropColor(unpack(E.media.backdropcolor))
        leaderboardFrameOne.btnStatus:SetBackdropBorderColor(unpack(E.media.bordercolor))

        leaderboardFrameOne.btnRealm:SetTemplate("Transparent")
        leaderboardFrameOne.btnRealm:SetBackdropColor(unpack(E.media.backdropcolor))
        leaderboardFrameOne.btnRealm:SetBackdropBorderColor(unpack(E.media.bordercolor))

        leaderboardFrameOne.btnGuild:SetTemplate("Transparent")
        leaderboardFrameOne.btnGuild:SetBackdropColor(unpack(E.media.backdropcolor))
        leaderboardFrameOne.btnGuild:SetBackdropBorderColor(unpack(E.media.bordercolor))

        leaderboardFrameOne.btnSettings:SetTemplate("Transparent")
        leaderboardFrameOne.btnSettings:SetBackdropColor(unpack(E.media.backdropcolor))
        leaderboardFrameOne.btnSettings:SetBackdropBorderColor(unpack(E.media.bordercolor))

        leaderboardFrameOne.btnExport:SetTemplate("Transparent")
        leaderboardFrameOne.btnExport:SetBackdropColor(unpack(E.media.backdropcolor))
        leaderboardFrameOne.btnExport:SetBackdropBorderColor(unpack(E.media.bordercolor))

        leaderboardFrameOne.btnExit:SetTemplate("Transparent")
        leaderboardFrameOne.btnExit:SetBackdropColor(unpack(E.media.backdropcolor))
        leaderboardFrameOne.btnExit:SetBackdropBorderColor(unpack(E.media.bordercolor))
    end
end)

function AL:showExport()
    hideAllTabs()

    if not leaderboardFrameOne.CopyChat then
        leaderboardFrameOne.CopyChat = CreateFrame('Frame', 'nChatCopy', leaderboardFrameOne, "BackdropTemplate")
        leaderboardFrameOne.CopyChat:SetWidth(700)
        leaderboardFrameOne.CopyChat:SetHeight(400)
        leaderboardFrameOne.CopyChat:SetPoint('LEFT', leaderboardFrameOne, 'LEFT', 20, 10)
        leaderboardFrameOne.CopyChat:SetFrameStrata('DIALOG')
        local backdrop = {
            bgFile = [[Interface\Buttons\WHITE8x8]],
            insets = {left = 3, right = 3, top = 4, bottom = 3},
            edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
            tile = true, tileSize = 16, edgeSize = 16
        }
        
        leaderboardFrameOne.CopyChat:SetBackdrop(backdrop)
        leaderboardFrameOne.CopyChat:SetBackdropColor(0, 0, 0, 0.7)
        
        if AL.ElvUI == true then
            leaderboardFrameOne.CopyChat:SetBackdropColor(unpack(E.media.backdropcolor))
            leaderboardFrameOne.CopyChat:SetBackdropBorderColor(unpack(E.media.bordercolor))
        end
    
        
        leaderboardFrameOne.CopyChatBox = CreateFrame('EditBox', 'nChatCopyBox', leaderboardFrameOne.CopyChat)
        leaderboardFrameOne.CopyChatBox:SetMultiLine(true)
        leaderboardFrameOne.CopyChatBox:SetAutoFocus(false)
        leaderboardFrameOne.CopyChatBox:EnableMouse(true)
        leaderboardFrameOne.CopyChatBox:SetFont('Fonts\\ARIALN.ttf', 13, 'THINOUTLINE')
        leaderboardFrameOne.CopyChatBox:SetWidth(650)
        leaderboardFrameOne.CopyChatBox:SetHeight(590)
        
        leaderboardFrameOne.ChatBoxScroll = CreateFrame('ScrollFrame', 'nChatCopyScroll', leaderboardFrameOne.CopyChat, 'UIPanelScrollFrameTemplate')
        leaderboardFrameOne.ChatBoxScroll:SetPoint('TOPLEFT', leaderboardFrameOne.CopyChat, 'TOPLEFT', 8, -15)
        leaderboardFrameOne.ChatBoxScroll:SetPoint('BOTTOMRIGHT', leaderboardFrameOne.CopyChat, 'BOTTOMRIGHT', -30, 8)
        leaderboardFrameOne.ChatBoxScroll:SetScrollChild(leaderboardFrameOne.CopyChatBox)
        
        leaderboardFrameOne.CopyChatBox.exporterText = CreateFrame('Frame', 'cleanBox')
        leaderboardFrameOne.CopyChatBox.exporterText.line1 = leaderboardFrameOne:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        leaderboardFrameOne.CopyChatBox.exporterText.line1:SetPoint("BOTTOM", 0, 65)
        leaderboardFrameOne.CopyChatBox.exporterText.line1:SetText("Copy the text above and import on the website: cata.achievementleaderboard.com")

        leaderboardFrameOne.CopyChatBox.exporterText.line2 = leaderboardFrameOne:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        leaderboardFrameOne.CopyChatBox.exporterText.line2:SetPoint("BOTTOM", 0, 50)
        leaderboardFrameOne.CopyChatBox.exporterText.line2:SetText("CTRL + A To Select, CTRL + C to Copy")
    else
        if not leaderboardFrameOne.CopyChat:IsVisible() then
            leaderboardFrameOne.CopyChat:Show()
            leaderboardFrameOne.CopyChatBox.exporterText.line1:Show()
            leaderboardFrameOne.CopyChatBox.exporterText.line2:Show()
        end
    end
    if leaderboardFrameOne.CopyChatBox then
        local fieldData = leaderboardFrameOne.CopyChatBox:GetNumLetters()
        if AL.LastDataUpdate == 0 or fieldData == 0 or (fieldData > 500 and AL.currentCharacter.lastExport < AL.LastDataUpdate) then
            local data = AL:getExportData()
            leaderboardFrameOne.CopyChatBox:SetText(data)
        end
    end
end

function showCharacterStatus()
    hideAllTabs()
    if not leaderboardFrameOne.CharacterStatusFrame then
        leaderboardFrameOne.CharacterStatusFrame = CreateFrame("ScrollFrame", "CharacterScrollFrame", leaderboardFrameOne, "UIPanelScrollFrameTemplate")
        leaderboardFrameOne.CharacterStatusFrame:SetSize(700, 450)
        leaderboardFrameOne.CharacterStatusFrame:SetPoint("TOPLEFT", 10, -50)
        leaderboardFrameOne.CharacterContentFrame = CreateFrame("Frame", "CharacterContentFrame", leaderboardFrameOne.CharacterStatusFrame)
        leaderboardFrameOne.CharacterContentFrame:SetSize(650, 15)
        leaderboardFrameOne.CharacterStatusFrame:SetScrollChild(leaderboardFrameOne.CharacterContentFrame)
    end
    leaderboardFrameOne.CharacterStatusFrame:Show()
    getCharacterInfoStatus()
end

function getCharacterInfoStatus()
    if leaderboardFrameOne.CharacterContentFrame:IsVisible() then
        if isUpdatingCharacterStatus then
            return  
        end
        local color = {	
            r = 0,
            g = 0,
            b = 0
        }
        if AL.currentCharacter.characterInfo.class ~= nil or AL.currentCharacter.characterInfo.class ~= "" then
            color = AL.ClassColours[string.upper(AL.currentCharacter.characterInfo.class)]
        end
        if not leaderboardFrameOne.CharacterContentFrame.name then
            leaderboardFrameOne.CharacterContentFrame.name = leaderboardFrameOne.CharacterContentFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
            leaderboardFrameOne.CharacterContentFrame.name:SetPoint("LEFT", 5, -10)
            leaderboardFrameOne.CharacterContentFrame.name:SetFont("Fonts\\FRIZQT__.TTF", 21, "OUTLINE")
        end
        leaderboardFrameOne.CharacterContentFrame.name:SetText(AL.currentCharacter.characterInfo.name)
        leaderboardFrameOne.CharacterContentFrame.name:SetTextColor(color.r, color.g, color.b)
        if not leaderboardFrameOne.CharacterContentFrame.guild then
            leaderboardFrameOne.CharacterContentFrame.guild = leaderboardFrameOne.CharacterContentFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
        end

        AL:getCurrentGuild()
        
        leaderboardFrameOne.CharacterContentFrame.guild:SetPoint("LEFT", leaderboardFrameOne.CharacterContentFrame.name, "RIGHT", 5, 0)
        leaderboardFrameOne.CharacterContentFrame.guild:SetFont("Fonts\\FRIZQT__.TTF", 21, "OUTLINE")
        if AL.currentCharacter.characterInfo.guild ~= nil and AL.currentCharacter.characterInfo.guild ~= "" then
            leaderboardFrameOne.CharacterContentFrame.guild:SetText("<"..AL.currentCharacter.characterInfo.guild..">")
        end

        if not leaderboardFrameOne.CharacterContentFrame.achievementPoints then
            leaderboardFrameOne.CharacterContentFrame.achievementPoints = leaderboardFrameOne.CharacterContentFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
        end
        leaderboardFrameOne.CharacterContentFrame.achievementPoints:SetPoint("TOP", leaderboardFrameOne.CharacterContentFrame.name, "BOTTOM", 30, -10)
        leaderboardFrameOne.CharacterContentFrame.achievementPoints:SetPoint("LEFT", leaderboardFrameOne.CharacterContentFrame.name, "BOTTOMLEFT", 0, 0)
        leaderboardFrameOne.CharacterContentFrame.achievementPoints:SetText("Achievement Points: " .. AL.currentCharacter.characterInfo.points)

        if not leaderboardFrameOne.CharacterContentFrame.achievementsCompleted then
            leaderboardFrameOne.CharacterContentFrame.achievementsCompleted = leaderboardFrameOne.CharacterContentFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
        end
        leaderboardFrameOne.CharacterContentFrame.achievementsCompleted:SetPoint("TOP", leaderboardFrameOne.CharacterContentFrame.achievementPoints, "BOTTOM", 30, -10)
        leaderboardFrameOne.CharacterContentFrame.achievementsCompleted:SetPoint("LEFT", leaderboardFrameOne.CharacterContentFrame.achievementPoints, "BOTTOMLEFT", 0, 0)
        local completed, _, completedByMe = AL:getTotalCompletedAchievements()
        leaderboardFrameOne.CharacterContentFrame.achievementsCompleted:SetText("Achievements Completed: " .. completed .. " (".. completedByMe ..")")

        if not leaderboardFrameOne.CharacterContentFrame.categoryoverview then
            leaderboardFrameOne.CharacterContentFrame.categoryoverview = leaderboardFrameOne.CharacterContentFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
        end
        leaderboardFrameOne.CharacterContentFrame.categoryoverview:SetPoint("TOP", leaderboardFrameOne.CharacterContentFrame.achievementsCompleted, "BOTTOM", 30, -10)
        leaderboardFrameOne.CharacterContentFrame.categoryoverview:SetPoint("LEFT", leaderboardFrameOne.CharacterContentFrame.achievementsCompleted, "BOTTOMLEFT", 0, 0)
        leaderboardFrameOne.CharacterContentFrame.categoryoverview:SetText("Category overview: ")

        for index, cat in pairs(AL.currentCharacter.categoryOverview) do
            local rowFrame = leaderboardFrameOne.CharacterContentFrame.categoryoverview["catFrame-"..index]
            if not rowFrame then
                rowFrame = leaderboardFrameOne.CharacterContentFrame:CreateFontString(nil , "OVERLAY", "GameFontHighlight")
            end
            local catTitle = GetCategoryInfo(cat.id);
            local distance = -((index - 1) * 20 + 10)
            if index == 1 then
                distance = -10
            end
            rowFrame:SetPoint("TOP", leaderboardFrameOne.CharacterContentFrame.categoryoverview, "BOTTOM", 0, distance)
            rowFrame:SetPoint("LEFT", leaderboardFrameOne.CharacterContentFrame.categoryoverview, "BOTTOMLEFT", 0, distance)
            rowFrame:SetText(" - "..catTitle..": ".. cat.completed)
            leaderboardFrameOne.CharacterContentFrame.categoryoverview["catFrame-"..index] = rowFrame
        end


        if not leaderboardFrameOne.CharacterContentFrame.featsofstrength then
            leaderboardFrameOne.CharacterContentFrame.featsofstrength = leaderboardFrameOne.CharacterContentFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
        end
        leaderboardFrameOne.CharacterContentFrame.featsofstrength:SetText("Feats of Strength: " .. select(2, AL:getTotalCompletedAchievements()))

        if not leaderboardFrameOne.CharacterContentFrame.totalMounts then
            leaderboardFrameOne.CharacterContentFrame.totalMounts = leaderboardFrameOne.CharacterContentFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
        end
        leaderboardFrameOne.CharacterContentFrame.totalMounts:SetPoint("TOP", leaderboardFrameOne.CharacterContentFrame.categoryoverview, "BOTTOM", 30, -((#AL.currentCharacter.categoryOverview+1)*20))
        leaderboardFrameOne.CharacterContentFrame.totalMounts:SetPoint("LEFT", leaderboardFrameOne.CharacterContentFrame.categoryoverview, "BOTTOMLEFT", 0, 0)
        leaderboardFrameOne.CharacterContentFrame.totalMounts:SetText("Total mounts collected: " .. #AL.currentCharacter.mounts)

        if not leaderboardFrameOne.CharacterContentFrame.totalPets then
            leaderboardFrameOne.CharacterContentFrame.totalPets = leaderboardFrameOne.CharacterContentFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
        end
        leaderboardFrameOne.CharacterContentFrame.totalPets:SetPoint("TOP", leaderboardFrameOne.CharacterContentFrame.totalMounts, "BOTTOM", 0, -10)
        leaderboardFrameOne.CharacterContentFrame.totalPets:SetPoint("LEFT", leaderboardFrameOne.CharacterContentFrame.totalMounts, "BOTTOMLEFT", 0, 0)
        leaderboardFrameOne.CharacterContentFrame.totalPets:SetText("Total pets collected: " .. #AL.currentCharacter.pets)

        if not leaderboardFrameOne.CharacterContentFrame.totalToys then
            leaderboardFrameOne.CharacterContentFrame.totalToys = leaderboardFrameOne.CharacterContentFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
        end
        leaderboardFrameOne.CharacterContentFrame.totalToys:SetPoint("TOP", leaderboardFrameOne.CharacterContentFrame.totalPets, "BOTTOM", 0, -10)
        leaderboardFrameOne.CharacterContentFrame.totalToys:SetPoint("LEFT", leaderboardFrameOne.CharacterContentFrame.totalPets, "BOTTOMLEFT", 0, 0)
        leaderboardFrameOne.CharacterContentFrame.totalToys:SetText("Total toys collected: " .. #AL.currentCharacter.toys)

        if not leaderboardFrameOne.CharacterContentFrame.professions then
            leaderboardFrameOne.CharacterContentFrame.professions = leaderboardFrameOne.CharacterContentFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
        end
        leaderboardFrameOne.CharacterContentFrame.professions:SetPoint("TOP", leaderboardFrameOne.CharacterContentFrame.totalToys, "BOTTOM", 0, -10)
        leaderboardFrameOne.CharacterContentFrame.professions:SetPoint("LEFT", leaderboardFrameOne.CharacterContentFrame.totalToys, "BOTTOMLEFT", 0, 0)
        leaderboardFrameOne.CharacterContentFrame.professions:SetText("Professions: ")
        local rowHeight = 20
        for index, prof in pairs(AL.currentCharacter.professions.primary) do
            local skillName = GetSpellInfo(prof.id)
            local rowFrame = leaderboardFrameOne.CharacterContentFrame["profFrame"..index]
            if not rowFrame then
                rowFrame = leaderboardFrameOne.CharacterContentFrame:CreateFontString(nil , "OVERLAY", "GameFontHighlight")
            end
            if index == 1 then
                rowFrame:SetPoint("TOP", leaderboardFrameOne.CharacterContentFrame.professions, "BOTTOM", 0, -10)
                rowFrame:SetPoint("LEFT", leaderboardFrameOne.CharacterContentFrame.professions, "BOTTOMLEFT", 0, 0)
            elseif index == 2 then
                rowFrame:SetPoint("TOP", leaderboardFrameOne.CharacterContentFrame.professions, "BOTTOM", 0, -30)
                rowFrame:SetPoint("LEFT", leaderboardFrameOne.CharacterContentFrame.professions, "BOTTOMLEFT", 0, 0)
            end
            rowFrame:SetText(" - "..skillName.." ("..prof.skilllvl.."), total recipes: " .. #prof.recipes)
            leaderboardFrameOne.CharacterContentFrame["profFrame"..index] = rowFrame
        end
        for index, prof in pairs(AL.currentCharacter.professions.secondary) do
            local skillName = GetSpellInfo(prof.id)
            local rowFrame = leaderboardFrameOne.CharacterContentFrame["profFrame"..index+#AL.currentCharacter.professions.primary]
            if not rowFrame then
                rowFrame = leaderboardFrameOne.CharacterContentFrame:CreateFontString(nil , "OVERLAY", "GameFontHighlight")
            end
            if index == 1 then
                rowFrame:SetPoint("TOP", leaderboardFrameOne.CharacterContentFrame.professions, "BOTTOM", 0, -50)
                rowFrame:SetPoint("LEFT", leaderboardFrameOne.CharacterContentFrame.professions, "BOTTOMLEFT", 0, 0)
            elseif index == 2 then
                rowFrame:SetPoint("TOP", leaderboardFrameOne.CharacterContentFrame.professions, "BOTTOM", 0, -70)
                rowFrame:SetPoint("LEFT", leaderboardFrameOne.CharacterContentFrame.professions, "BOTTOMLEFT", 0, 0)
            end
            rowFrame:SetText(" - "..skillName.." ("..prof.skilllvl.."), total recipes: " .. #prof.recipes)
            leaderboardFrameOne.CharacterContentFrame["profFrame"..index+#AL.currentCharacter.professions.primary] = rowFrame
        end
    end
end

function AL:showLeaderboard(showExport)
    leaderboardFrameOne:Show()
    if showExport then
        AL:showExport()
    end
    AL.LeaderboardScreenOpen = true
end

function AL:hideLeaderboard()
    leaderboardFrameOne:Hide()
    AL.LeaderboardScreenOpen = false
end

function tContainsName(table, item)
    local index = 1;
    while table[index] do
        if ( item == table[index].name ) then
                return 1, table[index], index;
        end
        index = index + 1;
    end
    return nil;
end

function createMycharacterFrame()
    hideAllTabs()

    if not leaderboardFrameOne.GuildTitle then
        leaderboardFrameOne.GuildTitle = leaderboardFrameOne:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
        leaderboardFrameOne.GuildTitle:SetPoint("TOP", leaderboardFrameOne, "TOP", 0, -50)
        leaderboardFrameOne.GuildTitle:SetText("My Characters")
        leaderboardFrameOne.GuildTitle:SetFontObject("GameFontHighlightLarge")
    end
    if leaderboardFrameOne.ColumnHeaderFrame and not leaderboardFrameOne.ColumnHeaderFrame:IsVisible() then leaderboardFrameOne.ColumnHeaderFrame:Show() end

    if not leaderboardFrameOne.ScrollGuildFrame then
        leaderboardFrameOne.ScrollGuildFrame = CreateFrame("ScrollFrame", "LeaderboardScrollFrame", leaderboardFrameOne, "UIPanelScrollFrameTemplate")
        leaderboardFrameOne.ScrollGuildFrame:SetSize(700, 400) 
        leaderboardFrameOne.ScrollGuildFrame:SetPoint("TOPLEFT", 10, -95)
        
        leaderboardFrameOne.ContentGuildFrame = CreateFrame("Frame", "LeaderboardContentFrame", leaderboardFrameOne.ScrollGuildFrame)
        leaderboardFrameOne.ContentGuildFrame:SetSize(700, 15)
        leaderboardFrameOne.ScrollGuildFrame:SetScrollChild(leaderboardFrameOne.ContentGuildFrame)

        leaderboardFrameOne.ColumnHeaderFrame:Show()
    end


    if leaderboardFrameOne.ScrollGuildFrame then
        leaderboardFrameOne.ScrollGuildFrame:Show()
        leaderboardFrameOne.ColumnHeaderFrame:Show()
        leaderboardFrameOne.GuildTitle:Show()
        getCharacterdData()
    end
end

function getCharacterdData()
    leaderboardFrameOne.ColumnHeaderFrame.column3Label:SetText("Select main")
    leaderboardFrameOne.ColumnHeaderFrame.column4Label:SetText("Remove")
    local characterdata = AL.tempStore.myCharacters
    local rowHeight = 20
    local numRows = #characterdata
    local contentGuildFrame = leaderboardFrameOne.ContentGuildFrame

    for _, child in ipairs({contentGuildFrame:GetChildren()}) do
        child:Hide()
        child:ClearAllPoints()
    end

    AL:getMyCharacters()

    local radioButtonGroup = CreateFrame("Frame", "RadioButtonGroup", contentGuildFrame)
    radioButtonGroup:SetAllPoints()

    for rowIndex, rowData in ipairs(characterdata) do
        local rowFrame = contentGuildFrame["RowFrame"..rowIndex]

        if not rowFrame then
            rowFrame = CreateFrame("Frame", "RowFrame"..rowIndex, contentGuildFrame)
            rowFrame:SetSize(380, rowHeight)
            contentGuildFrame["RowFrame"..rowIndex] = rowFrame
        end

        rowFrame:SetPoint("TOPLEFT", 0, -(rowHeight * (rowIndex - 1)))

        local color = AL.ClassColours["UNKNOWN"]
        if rowData.class ~= nil then
            color = AL.ClassColours[string.upper(rowData.class)]
        end

        rowFrame.cell = rowFrame.cell or rowFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        rowFrame.cell:SetPoint("LEFT", (0) * 200 + 10, 0)
        if AL.settings.mainCharacter == rowData.guid or rowData.ap == 0 then
            rowFrame.cell:SetText(rowData.points)
        else
            rowFrame.cell:SetText(rowData.ap)
        end

        rowFrame.cell2 = rowFrame.cell2 or rowFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
        rowFrame.cell2:SetPoint("LEFT", (1) * 150 + 10, 0)
        rowFrame.cell2:SetText(rowData.name .. " - " .. rowData.realm)
        rowFrame.cell2:SetTextColor(color.r, color.g, color.b)

        rowFrame.radioButton = rowFrame.radioButton or CreateFrame("CheckButton", "RadioButton" .. rowIndex, rowFrame, "UIRadioButtonTemplate")
        rowFrame.radioButton:SetPoint("LEFT", (2) * 200 + 10, 0)
        rowFrame.radioButton.rowData = rowData
        rowFrame.radioButton:SetScript("OnClick", function(self)
            for i, data in ipairs(characterdata) do
                local otherRowFrame = contentGuildFrame["RowFrame"..i]
                if otherRowFrame and otherRowFrame.radioButton ~= self then
                    otherRowFrame.radioButton:SetChecked(false)
                end
            end
            selectedRowData = self.rowData
            AL.settings.mainCharacter = selectedRowData.guid
            AL.currentCharacter.lastExport = 0
            AL:sendLeaderboardMessage("Selected main: " .. selectedRowData.name .. " - " .. selectedRowData.realm)
        end)

        rowFrame.btnRemove = rowFrame.btnRemove or CreateFrame("Button", "deleteChar" .. rowIndex, rowFrame, "UIPanelCloseButton")
        rowFrame.btnRemove:SetPoint("LEFT", (2) * 250 + 20, 0)
        rowFrame.btnRemove:SetSize(30, 30)
        rowFrame.btnRemove:SetScript("OnClick", function(self)
            AL:removeCharacter(rowData.guid)
            getCharacterdData()
        end)

        if rowData.guid == AL.settings.mainCharacter then
            rowFrame.radioButton:SetChecked(true)
        end

        rowFrame:Show()
    end

    contentGuildFrame:SetWidth(500)  -- Adjust the total width as needed
    isUpdatingGuildData = false
end

function createGuildInfoScreen()
    hideAllTabs()
    getGuildInfo()
    leaderboardFrameOne.guildInfo:Show()
end

function getGuildInfo()
    if not leaderboardFrameOne.guildInfo then
        leaderboardFrameOne.guildInfo = CreateFrame("Frame", "GuildInfoContentFrame", leaderboardFrameOne)
        leaderboardFrameOne.guildInfo:SetPoint("TOPLEFT", leaderboardFrameOne, "TOPLEFT", 10, -50)
        leaderboardFrameOne.guildInfo:SetSize(650, 15)
    end

    local title = leaderboardFrameOne.guildInfo:CreateFontString(nil, "OVERLAY")
    title:SetFontObject("GameFontHighlightLarge")
    title:SetPoint("TOP", leaderboardFrameOne.guildInfo, "TOP", 0, -10)
    title:SetText("Guild Export Info")

    if AL.currentCharacter.guild ~= nil and AL.currentCharacter.guild.info ~= nil then
        local guildInfo = AL.currentCharacter.guild.info

        local data = {
            { label = "Name: ", value = guildInfo.name or "N/A" },
            { label = "Achievements Completed: ", value = guildInfo.completed or "N/A" },
            { label = "Total Achievements: ", value = guildInfo.total or "N/A" },
            { label = "Total Points: ", value = guildInfo.points or "N/A" },
        }
        
        for i, row in ipairs(data) do
            local naamText = leaderboardFrameOne.guildInfo:CreateFontString(nil, "OVERLAY", "GameFontNormal")
            naamText:SetPoint("TOPLEFT", 10, -30 * i - 10)
            naamText:SetText(row.label .. row.value)
        end
    else
        local naamText = leaderboardFrameOne.guildInfo:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        naamText:SetPoint("TOPLEFT", 10, -30 * 1 - 10)
        naamText:SetText("You are not in a guild")
    end
    leaderboardFrameOne.guildInfo:Show()
end

function hideAllTabs()
    if leaderboardFrameOne.guildInfo and leaderboardFrameOne.guildInfo:IsVisible() then
        leaderboardFrameOne.guildInfo:Hide()
    end
    if leaderboardFrameOne.ColumnHeaderFrame and leaderboardFrameOne.ColumnHeaderFrame:IsVisible() then
        leaderboardFrameOne.ColumnHeaderFrame:Hide()
    end
    if leaderboardFrameOne.ScrollRealmFrame and leaderboardFrameOne.ScrollRealmFrame:IsVisible() then
        leaderboardFrameOne.ScrollRealmFrame:Hide()
    end
    if leaderboardFrameOne.RealmTitle and leaderboardFrameOne.RealmTitle:IsVisible() then
        leaderboardFrameOne.RealmTitle:Hide()
    end
    if leaderboardFrameOne.ScrollGuildFrame and leaderboardFrameOne.ScrollGuildFrame:IsVisible() then
        leaderboardFrameOne.ScrollGuildFrame:Hide()
    end
    if leaderboardFrameOne.GuildTitle and leaderboardFrameOne.GuildTitle:IsVisible() then
        leaderboardFrameOne.GuildTitle:Hide()
    end
    if leaderboardFrameOne.CopyChat and leaderboardFrameOne.CopyChat:IsVisible() then
        leaderboardFrameOne.CopyChat:Hide()
        leaderboardFrameOne.CopyChatBox.exporterText.line1:Hide()
        leaderboardFrameOne.CopyChatBox.exporterText.line2:Hide()
    end
    if leaderboardFrameOne.CharacterStatusFrame and leaderboardFrameOne.CharacterStatusFrame:IsVisible() then
        leaderboardFrameOne.CharacterStatusFrame:Hide()
    end
    if leaderboardFrameOne.ColumnLeaderboardHeaderFrame and leaderboardFrameOne.ColumnLeaderboardHeaderFrame:IsVisible() then
        leaderboardFrameOne.ColumnLeaderboardHeaderFrame:Hide()
    end
    if leaderboardFrameOne.ScrollLeaderboardFrame and leaderboardFrameOne.ScrollLeaderboardFrame:IsVisible() then
        leaderboardFrameOne.ScrollLeaderboardFrame:Hide()
    end
    if leaderboardFrameOne.leaderboardTitle and leaderboardFrameOne.leaderboardTitle:IsVisible() then
        leaderboardFrameOne.leaderboardTitle:Hide()
    end
end